;+
; NAME: eis_status_sts2_data_dumper__plotter.pro
;
; PURPOSE: 
;      
; CATEGORY:
;
; CALLING SEQUENCE: 
;
; INPUTS: 
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: 
;
; CALLS:
;
; COMMON BLOCKS: None
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	03/June/2006 v1.0 mcrw wrote
;       15/Nov/2006  v1.1 mcrw minor corrections
;       03/Dec/2006  v1.2 mcrw minor corrections
;
;-------------------------------------------------------------------------------------------------

pro eis_status_sts2_data_dumper::check_cam_voltages, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_voltages'
  
  print, '        cam_voltages'

  title_str = 'CAM voltages (volts)            min            max                avg'

  self->retrieve, 'cam_voltages', 'CAM_P5V1_DIG', minp0,  maxp0,  avg0
  self->retrieve, 'cam_voltages', 'CAM_P2V5_DIG', minp1,  maxp1,  avg1
  self->retrieve, 'cam_voltages', 'CAM_P5V_AN_A', minp2,  maxp2,  avg2
  self->retrieve, 'cam_voltages', 'CAM_P5V_AN_B', minp3,  maxp3,  avg3
  self->retrieve, 'cam_voltages', 'CAM_N5V_AN_A', minp4,  maxp4,  avg4
  self->retrieve, 'cam_voltages', 'CAM_N5V_AN_B', minp5,  maxp5,  avg5
  self->retrieve, 'cam_voltages', 'CAM_P36V_A',   minp6,  maxp6,  avg6
  self->retrieve, 'cam_voltages', 'CAM_P36V_B',   minp7,  maxp7,  avg7
  self->retrieve, 'cam_voltages', 'CAM_P12V_A',   minp8,  maxp8,  avg8
  self->retrieve, 'cam_voltages', 'CAM_P12V_B',   minp9,  maxp9,  avg9
  self->retrieve, 'cam_voltages', 'CAM_N10V_A',   minp10, maxp10, avg10
  self->retrieve, 'cam_voltages', 'CAM_N10V_B',   minp11, maxp11, avg11

  p0_str  = '+5.1v dig             ' + eis_num2str(minp0,  type='volts') + eis_num2str(maxp0,  type='volts') + eis_num2Str(avg0,  type='volts')
  p1_str  = '+2.5v dig             ' + eis_num2str(minp1,  type='volts') + eis_num2str(maxp1,  type='volts') + eis_num2Str(avg1,  type='volts')
  p2_str  = '+5v an a              ' + eis_num2str(minp2,  type='volts') + eis_num2str(maxp2,  type='volts') + eis_num2Str(avg2,  type='volts')
  p3_str  = '+5v an b              ' + eis_num2str(minp3,  type='volts') + eis_num2str(maxp3,  type='volts') + eis_num2Str(avg3,  type='volts')
  p4_str  = '-5v an a              ' + eis_num2str(minp4,  type='volts') + eis_num2str(maxp4,  type='volts') + eis_num2Str(avg4,  type='volts')
  p5_str  = '-5v an b              ' + eis_num2str(minp5,  type='volts') + eis_num2str(maxp5,  type='volts') + eis_num2Str(avg5,  type='volts')
  p6_str  = '+36v a                ' + eis_num2str(minp6,  type='volts') + eis_num2str(maxp6,  type='volts') + eis_num2Str(avg6,  type='volts')
  p7_str  = '+36v b                ' + eis_num2str(minp7,  type='volts') + eis_num2str(maxp7,  type='volts') + eis_num2Str(avg7,  type='volts')
  p8_str  = '+12v a                ' + eis_num2str(minp8,  type='volts') + eis_num2str(maxp8,  type='volts') + eis_num2Str(avg8,  type='volts')
  p9_str  = '+12v b                ' + eis_num2str(minp9,  type='volts') + eis_num2str(maxp9,  type='volts') + eis_num2Str(avg9,  type='volts')
  p10_str = '-10v a                ' + eis_num2str(minp10, type='volts') + eis_num2str(maxp10, type='volts') + eis_num2Str(avg10, type='volts')
  p11_str = '-10v b                ' + eis_num2str(minp11, type='volts') + eis_num2str(maxp11, type='volts') + eis_num2Str(avg11, type='volts')

  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu, p2_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu, p5_str
  printf, lu, p6_str
  printf, lu, p7_str
  printf, lu, p8_str
  printf, lu, p9_str
  printf, lu, p10_str
  printf, lu, p11_str
  printf, lu
  
end

pro eis_status_sts2_data_dumper::check_cam_currents, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_currents'
  
  print, '        cam_currents'

  title_str = 'CAM currents (amps)             min            max                avg'

  self->retrieve, 'cam_currents', 'CAM_P5V1_DIG',  minp0, maxp0, avg0
  self->retrieve, 'cam_currents', 'CAM_P2V5I_DIG', minp1, maxp1, avg1
  self->retrieve, 'cam_currents', 'CAM_P5VI_AN_A', minp2, maxp2, avg2
  self->retrieve, 'cam_currents', 'CAM_P5VI_AN_B', minp3, maxp3, avg3
  self->retrieve, 'cam_currents', 'CAM_N5VI_AN_A', minp4, maxp4, avg4
  self->retrieve, 'cam_currents', 'CAM_N5VI_AN_B', minp5, maxp5, avg5
  self->retrieve, 'cam_currents', 'CAM_P36VI_A',   minp6, maxp6, avg6
  self->retrieve, 'cam_currents', 'CAM_P36VI_B',   minp7, maxp7, avg7
  self->retrieve, 'cam_currents', 'CAM_P12VI_A',   minp8, maxp8, avg8
  self->retrieve, 'cam_currents', 'CAM_P12VI_B',   minp9, maxp9, avg9

  p0_str  = '+5.1v dig             ' + eis_num2str(minp0,  type='amps') + eis_num2str(maxp0,  type='amps') + eis_num2str(avg0,  type='amps')
  p1_str  = '+2.5v dig             ' + eis_num2str(minp1,  type='amps') + eis_num2str(maxp1,  type='amps') + eis_num2str(avg1,  type='amps')
  p2_str  = '+5v ana a             ' + eis_num2str(minp2,  type='amps') + eis_num2str(maxp2,  type='amps') + eis_num2str(avg2,  type='amps')
  p3_str  = '+5v ana b             ' + eis_num2str(minp3,  type='amps') + eis_num2str(maxp3,  type='amps') + eis_num2str(avg3,  type='amps')
  p4_str  = '-5v ana a             ' + eis_num2str(minp4,  type='amps') + eis_num2str(maxp4,  type='amps') + eis_num2str(avg4,  type='amps')
  p5_str  = '-5v ana b             ' + eis_num2str(minp5,  type='amps') + eis_num2str(maxp5,  type='amps') + eis_num2str(avg5,  type='amps')
  p6_str  = '+36v a                ' + eis_num2str(minp6,  type='amps') + eis_num2str(maxp6,  type='amps') + eis_num2str(avg6,  type='amps')
  p7_str  = '+36v b                ' + eis_num2str(minp7,  type='amps') + eis_num2str(maxp7,  type='amps') + eis_num2str(avg7,  type='amps')
  p8_str  = '+12v a                ' + eis_num2str(minp8,  type='amps') + eis_num2str(maxp8,  type='amps') + eis_num2str(avg8,  type='amps')
  p9_str  = '+12v b                ' + eis_num2str(minp9,  type='amps') + eis_num2str(maxp9,  type='amps') + eis_num2str(avg9,  type='amps')

  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu, p2_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu, p5_str
  printf, lu, p6_str
  printf, lu, p7_str
  printf, lu, p8_str
  printf, lu, p9_str
  printf, lu
  
end

pro eis_status_sts2_data_dumper::check_cam_ccd_biases, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_ccd_biases'
  
  print, '        cam_ccd_biases'

  title_str = 'CAM ccd biases (volts)           min            max                avg'

  self->retrieve, 'cam_ccd_biases', 'CAM_VOD_A', minp0, maxp0, avg0
  self->retrieve, 'cam_ccd_biases', 'CAM_VRD_A', minp1, maxp1, avg1
  self->retrieve, 'cam_ccd_biases', 'CAM_VSS_A', minp2, maxp2, avg2
  self->retrieve, 'cam_ccd_biases', 'CAM_VOD_B', minp3, maxp3, avg3
  self->retrieve, 'cam_ccd_biases', 'CAM_VRD_B', minp4, maxp4, avg4
  self->retrieve, 'cam_ccd_biases', 'CAM_VSS_B', minp5, maxp5, avg5
  self->retrieve, 'cam_ccd_biases', 'CAM_VOD',   minp6, maxp6, avg6
  self->retrieve, 'cam_ccd_biases', 'CAM_VRD',   minp7, maxp7, avg7
  self->retrieve, 'cam_ccd_biases', 'CAM_VSS',   minp8, maxp8, avg8

  p0_str  = 'VOD A                 ' + eis_num2str(minp0,  type='volts') + eis_num2str(maxp0,  type='volts') + eis_num2str(avg0,  type='volts')
  p1_str  = 'VRD A                 ' + eis_num2str(minp1,  type='volts') + eis_num2str(maxp1,  type='volts') + eis_num2str(avg1,  type='volts')
  p2_str  = 'VSS A                 ' + eis_num2str(minp2,  type='volts') + eis_num2str(maxp2,  type='volts') + eis_num2str(avg2,  type='volts')
  p3_str  = 'VOD B                 ' + eis_num2str(minp3,  type='volts') + eis_num2str(maxp3,  type='volts') + eis_num2str(avg3,  type='volts')
  p4_str  = 'VRD B                 ' + eis_num2str(minp4,  type='volts') + eis_num2str(maxp4,  type='volts') + eis_num2str(avg4,  type='volts')
  p5_str  = 'VSS B                 ' + eis_num2str(minp5,  type='volts') + eis_num2str(maxp5,  type='volts') + eis_num2str(avg5,  type='volts')
  p6_str  = 'VOD                   ' + eis_num2str(minp6,  type='volts') + eis_num2str(maxp6,  type='volts') + eis_num2str(avg6,  type='volts')
  p7_str  = 'VRD                   ' + eis_num2str(minp7,  type='volts') + eis_num2str(maxp7,  type='volts') + eis_num2str(avg7,  type='volts')
  p8_str  = 'VSS                   ' + eis_num2str(minp8,  type='volts') + eis_num2str(maxp8,  type='volts') + eis_num2str(avg8,  type='volts')

  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu, p2_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu, p5_str
  printf, lu, p6_str
  printf, lu, p7_str
  printf, lu, p8_str
  printf, lu
end

pro eis_status_sts2_data_dumper::check_cam_psu_voltages, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_psu_voltages'
  
  print, '        cam_psu_voltages'

  title_str = 'CAM psu voltages (volts)         min            max                avg'

  self->retrieve, 'cam_psu_voltages', 'PSU_CAM_P39V', minp0, maxp0, avg0
  self->retrieve, 'cam_psu_voltages', 'PSU_CAM_P7V',  minp1, maxp1, avg1
  self->retrieve, 'cam_psu_voltages', 'PSU_CAM_N8V',  minp2, maxp2, avg2
  self->retrieve, 'cam_psu_voltages', 'PSU_CAM_P8V',  minp3, maxp3, avg3
  self->retrieve, 'cam_psu_voltages', 'PSU_CAM_P13V', minp4, maxp4, avg4

  p0_str  = '+39v                  ' + eis_num2str(minp0,  type='volts') + eis_num2str(maxp0,  type='volts') + eis_num2str(avg0,  type='volts')
  p1_str  = '+7v                   ' + eis_num2str(minp1,  type='volts') + eis_num2str(maxp1,  type='volts') + eis_num2str(avg1,  type='volts')
  p2_str  = '-8v                   ' + eis_num2str(minp2,  type='volts') + eis_num2str(maxp2,  type='volts') + eis_num2str(avg2,  type='volts')
  p3_str  = '+8v                   ' + eis_num2str(minp3,  type='volts') + eis_num2str(maxp3,  type='volts') + eis_num2str(avg3,  type='volts')
  p4_str  = '+13v                  ' + eis_num2str(minp4,  type='volts') + eis_num2str(maxp4,  type='volts') + eis_num2str(avg4,  type='volts')
  
  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu, p2_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu
  
end

pro eis_status_sts2_data_dumper::check_cam_psu_currents, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_psu_currents'
  
  print, '        cam_psu_currents'

  title_str = 'CAM psu currents (amps)          min            max                avg'

  self->retrieve, 'cam_psu_currents', 'PSU_CAM_P39VI', minp0, maxp0, avg0
  self->retrieve, 'cam_psu_currents', 'PSU_CAM_P7VI',  minp1, maxp1, avg1
  self->retrieve, 'cam_psu_currents', 'PSU_CAM_N8VI',  minp2, maxp2, avg2
  self->retrieve, 'cam_psu_currents', 'PSU_CAM_P8VI',  minp3, maxp3, avg3
  self->retrieve, 'cam_psu_currents', 'PSU_CAM_P13VI', minp4, maxp4, avg4

  p0_str  = '+39v                  ' + eis_num2str(minp0,  type='amps') + eis_num2str(maxp0,  type='amps') + eis_num2str(avg0,  type='amps')
  p1_str  = '+7v                   ' + eis_num2str(minp1,  type='amps') + eis_num2str(maxp1,  type='amps') + eis_num2str(avg1,  type='amps')
  p2_str  = '-8v                   ' + eis_num2str(minp2,  type='amps') + eis_num2str(maxp2,  type='amps') + eis_num2str(avg2,  type='amps')
  p3_str  = '+8v                   ' + eis_num2str(minp3,  type='amps') + eis_num2str(maxp3,  type='amps') + eis_num2str(avg3,  type='amps')
  p4_str  = '+13v                  ' + eis_num2str(minp4,  type='amps') + eis_num2str(maxp4,  type='amps') + eis_num2str(avg4,  type='amps')
  
  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu, p2_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu
end

pro eis_status_sts2_data_dumper::check_cam_icu_parameters, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_icu_parameters'
  
  print, '        cam_icu_parameters'
  
  title_str = 'CAM ICU parameters               min            max'

  self->retrieve, 'cam_icu_parameters', 'EIS_XRT_X',    minp3,  maxp3,  avg3
  self->retrieve, 'cam_icu_parameters', 'EIS_XRT_Y',    minp4,  maxp4,  avg4
  self->retrieve, 'cam_icu_parameters', 'FT_XF',        minp15, maxp15, avg15
  self->retrieve, 'cam_icu_parameters', 'FT_YF',        minp16, maxp16, avg16
  self->retrieve, 'cam_icu_parameters', 'FT_XBIN_PEAK', minp17, maxp17, avg17
  self->retrieve, 'cam_icu_parameters', 'FT_YBIN_PEAK', minp18, maxp18, avg18
  self->retrieve, 'cam_icu_parameters', 'ET_XF',        minp19, maxp19, avg19
  self->retrieve, 'cam_icu_parameters', 'ET_YF',        minp20, maxp20, avg20
  self->retrieve, 'cam_icu_parameters', 'ET_XBIN_PEAK', minp21, maxp21, avg21
  self->retrieve, 'cam_icu_parameters', 'ET_YBIN_PEAK', minp22, maxp22, avg22

  p3_str  = 'EIS_XRT_X             ' + eis_num2str(minp3,  type='count') + eis_num2str(maxp3,  type='count') + eis_num2str(avg3,  type='count')
  p4_str  = 'EIS_XRT_Y             ' + eis_num2str(minp4,  type='count') + eis_num2str(maxp4,  type='count') + eis_num2str(avg4,  type='count')
  p15_str = 'FT_XF                 ' + eis_num2str(minp15, type='count') + eis_num2str(maxp15, type='count') + eis_num2str(avg15, type='count')
  p16_str = 'FT_YF                 ' + eis_num2str(minp16, type='count') + eis_num2str(maxp16, type='count') + eis_num2str(avg16, type='count')
  p17_str = 'FT_XBIN_PEAK          ' + eis_num2str(minp17, type='count') + eis_num2str(maxp17, type='count') + eis_num2str(avg17, type='count')
  p18_str = 'FT_YBIN_PEAK          ' + eis_num2str(minp18, type='count') + eis_num2str(maxp18, type='count') + eis_num2str(avg18, type='count')
  p19_str = 'ET_XF                 ' + eis_num2str(minp19, type='count') + eis_num2str(maxp19, type='count') + eis_num2str(avg19, type='count')
  p20_str = 'ET_YF                 ' + eis_num2str(minp20, type='count') + eis_num2str(maxp20, type='count') + eis_num2str(avg20, type='count')
  p21_str = 'ET_XBIN_PEAK          ' + eis_num2str(minp21, type='count') + eis_num2str(maxp21, type='count') + eis_num2str(avg21, type='count')
  p22_str = 'ET_YBIN_PEAK          ' + eis_num2str(minp22, type='count') + eis_num2str(maxp22, type='count') + eis_num2str(avg22, type='count')

  printf, lu, title_str
  printf, lu, p3_str
  printf, lu, p4_str
  printf, lu, p15_str
  printf, lu, p16_str
  printf, lu, p17_str
  printf, lu, p18_str
  printf, lu, p19_str
  printf, lu, p20_str
  printf, lu, p21_str
  printf, lu, p22_str
  printf, lu
        
end

pro eis_status_sts2_data_dumper::check_cam_misc, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_misc'
  
  print, '        cam_misc'

  title_str = 'CAM misc                         min            max'

  self->retrieve, 'cam_misc', 'CAM_CTL_REG1',    minp0, maxp0
  self->retrieve, 'cam_misc', 'CAM_CTL_REG2',    minp1, maxp1
  self->retrieve, 'cam_misc', 'CAM_SEU_COUNTER', minp2, maxp2

  p0_str  = 'Ctl reg 1             ' + eis_num2str(minp0,  type='count') + eis_num2str(maxp0,  type='count')
  p1_str  = 'Ctl reg 2             ' + eis_num2str(minp1,  type='count') + eis_num2str(maxp1,  type='count')
  p2_str  = 'SEU count             ' + eis_num2str(minp2,  type='count') + eis_num2str(maxp2,  type='count')

  printf, lu, title_str
  printf, lu, p2_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu
  
end

pro eis_status_sts2_data_dumper::check_cam_temperatures, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_temperatures'
  
  print, '        cam_temperatures'

  title_str = 'CAM temperatures (C)             min            max                avg'

  self->retrieve, 'cam_temperatures', 'CAM_UP_TEMP', minp0, maxp0, avg0
  self->retrieve, 'cam_temperatures', 'CAM_LO_TEMP', minp1, maxp1, avg1

  p0_str  = 'Upper                 ' + eis_num2str(minp0, type='degC') + eis_num2str(maxp0, type='degC') + eis_num2str(avg0, type='degC')
  p1_str  = 'Lower                 ' + eis_num2str(minp1, type='degC') + eis_num2str(maxp1, type='degC') + eis_num2str(avg1, type='degC')
  
  printf, lu, title_str
  printf, lu, p0_str
  printf, lu, p1_str
  printf, lu

end

pro eis_status_sts2_data_dumper::check_cam_spacecraft, lu
  self->trace, 'eis_status_sts2_data_dumper::check_cam_spacecraft'
  
  print, '        cam_spacecraft'
  
  title_str = 'CAM currentss (amps)             min            max                avg'
  title_str = 'CAM currentss (amps)             min            max                avg'

  self->retrieve, 'cam_spacecraft', 'TIME', minp0, maxp0
  self->retrieve, 'cam_spacecraft', 'SEQ_COUNTER', minp1, maxp1

end

pro eis_status_sts2_data_dumper::check, lu
  self->trace, 'eis_status_sts2_data_dumper::check'
  
  print, 'eis_status_sts2_data_dumper::check'
  
  self->check_cam_voltages,       lu
  self->check_cam_currents,       lu
  self->check_cam_ccd_biases,     lu
  self->check_cam_psu_voltages,   lu
  self->check_cam_psu_currents,   lu
  self->check_cam_icu_parameters, lu
  self->check_cam_misc,           lu
  self->check_cam_temperatures,   lu
;  self->check_cam_spacecraft,     lu

end
